<template>
  <div class="canceled-application">
    <div class="canceled-application-cause">Укажите причину</div>
    <ob-input
        v-model="cause"
        label="Причина аннулирования"
        required
        placeholder="Опишите причину"
    />
    <p class="canceled-application-add">Можете добавить документ или файл</p>
    <ob-uploader
        class="d-none"
        ref="uploader"
        @change="onUpload($event)"
        @removeFile="onRemoveFile"
    />
    <div class="canceled-application-button">
      <ob-button
          label="Аннулировать"
          :disabled="!cause && !uploader.files.length"
          @click="onCancelAdvance"
      />
      <ob-button label="Закрыть" @click="cancel"/>
    </div>
  </div>
</template>

<script>
  import ObInput from 'common-components/src/obComponents/obInput';
  import obUploader from 'common-components/src/obComponents/obUploader';
  import ObButton from "common-components/src/obComponents/obButton";
  import {mapActions} from 'vuex';

  export default {
    name: "canceledApplication",
    components: {
      ObInput,
      obUploader,
      ObButton
    },
    data() {
      return {
        cause: '',
        uploader: {
          files: [],
          isHide: false
        }
      }
    },
    methods: {
      ...mapActions({
        changeStatusAdvance: 'advances/changeStatusAdvance'
      }),
      onUpload(files) {
        this.uploader.files = [ ...files ]
      },
      onRemoveFile() {
        const _tmp = {
          files: [],
          isHide: false
        }
        this.uploader = { ..._tmp }
      },
      cancel() {
        this.onRemoveFile();
        this.cause = '';
        this.$emit('closeCancel')
      },
      onCancelAdvance () {
        const _params = {
          event: 'CANCELLED_BY_CLIENT',
          reason: this.cause,
          fileUuid: this.uploader.files[0]?.uuid || ''
        }
        this.changeStatusAdvance(_params)
          .then(() => {
            this.$emit('closeCancel')
          })
          .catch((e) => {
            console.error(e);
            this.$notification({
              type: 'system_notification_error',
              message: 'Ошибка аннулирования'
            });
          })
      }
    }
  }
</script>

<style scoped lang="scss">
  .canceled-application {
    color: $color-text-base;
    &-cause {
      margin-bottom: 10px;
      font-weight: bold;
      font-size: 16px;
      line-height: 20px;
      letter-spacing: 0.4px;
    }
    &-add {
      margin: 30px 0 10px;
      font-size: 14px;
      line-height: 18px;
      letter-spacing: 0.2px;
    }
  }
</style>

<style lang="scss">
  .canceled-application-button {
    display: flex;
    padding-top: 41px;
    button {
      border-radius: 10px !important;
      &:first-child {
        background: $color-error !important;
        margin-right: 10px;
      }
      &:last-child {
        background: transparent !important;
        span {
          color: $color-blue-navy-blue !important;
        }
      }
    }
  }
</style>
